#include <Xm/Xm.h>
#include <Xm/Form.h>
#include <Xm/TextF.h>
#include <Xm/Label.h>
#include <Xm/RowColumn.h>
#include <Xm/PushB.h>
#include <Xm/ToggleB.h>
#include <Xm/List.h>
#include <Xm/BulletinB.h>

/* Inventor */
#include <Inventor/nodes/SoSeparator.h>
#include <Inventor/nodes/SoPerspectiveCamera.h>
#include <Inventor/nodes/SoMaterial.h>
#include <Inventor/nodes/SoMaterialBinding.h>
#include <Inventor/nodes/SoFont.h>
#include <Inventor/nodes/SoText3.h>
#include <Inventor/nodes/SoDirectionalLight.h>


/* End Inventor */


#include <ctype.h>
#include <string.h>
#include "NewInterPlann.h"



//
//Array of chars
//

//--> Add a new selection: Select EDGE (Last one)

DataToApp::DataToApp(){
    _doReadNext=FALSE;
    _showCoordSystem=FALSE;
}

DataToApp::~DataToApp(){
}

// copy the filename to the Data

// Public constructor:
M_InterPlann::M_InterPlann(
Widget parent,
   const char *name,
   SbBool buildInsideParent,
   int num_digits)
   : SoXtRenderArea(parent, name, buildInsideParent
           ,FALSE,    FALSE)
{
   Interface = new DataToApp;
   constructorCommon();
}

M_InterPlann::~M_InterPlann(){

delete callbackList;
/*delete Interface; */
}


void
M_InterPlann::constructorCommon()
{
 // Allocate space for private vars:
  callbackList = new SoCallbackList;

 //  Interface = new M_InterfDataXwithInv;

  // Inventor Nodes
  Root = new SoSeparator;

  Camera = new SoPerspectiveCamera;
  Light = new SoDirectionalLight;
  Material = new SoMaterial;
//  SoMaterialBinding *binding = new SoMaterialBinding;
//  Material->diffuseColor.set1Value(0,SbColor(0, 1 , 0));
//  Material->diffuseColor.set1Value(1,SbColor(.1, .1, .1));
//  binding->value = SoMaterialBinding::PER_PART;

  userScene=NULL;
//  SoFont *font = new SoFont;
//  font->name.setValue("Times-Roman");
//  font->size.setValue(10);

//  SoText3 *text3= new SoText3;
//  text3->parts= SoText3::ALL;
//  text3->string="<>";


  Root->addChild(Camera);
//  Root->addChild(Light);
// Root->addChild(font);
//  Root->addChild(Material);
//  Root->addChild(binding);
//  Root->addChild(text3);

  Root->ref();

 /* End Inventor's part */

  Widget w = buildWidget( getParentWidget() );
  setBaseWidget( w );

  /* Inventor */
/*
   Camera->viewAll(Root, getViewportRegion(), 2.0);
   SoXtRenderArea::setSceneGraph(Root);
   SbViewportRegion newRegion(10,10);
   SoXtRenderArea::setViewportRegion( newRegion );
   SoXtRenderArea::setTitle("Controls");
*/
/* End Inventor */
}


void
M_InterPlann::setSceneGraph(SoNode *newScene){

   // Replace the existing scene with this one
   if (userScene != NULL)
        Root->replaceChild(userScene, newScene);
   else
        Root->addChild(newScene);
   userScene = newScene;

   // Make certain the scene is in view
   Camera->viewportMapping = SoCamera::ADJUST_CAMERA;
   Camera->viewAll(Root, getViewportRegion(), 2.0);

   // Render area will handle redraws for us
   SoXtRenderArea::setSceneGraph(Root);
}


Widget
M_InterPlann::buildWidget(Widget parent)
{

   Arg args[20];
   int n, i;

   form = XtVaCreateWidget( getWidgetName(),
                                 xmFormWidgetClass,
                                 parent,
			         XmNwidth, 700,
			         XmNheight, 700,
			         NULL);  //it was NULL, 0

  // Register the widget, so we can get resources
   registerWidget(form);

  // Create render area
   raWidget = SoXtRenderArea::buildWidget(form);


//A row column for 3 buttons
   threeButtons =XtVaCreateManagedWidget("threeButtons", xmRowColumnWidgetClass,
					 form,
					 XmNleftAttachment,   XmATTACH_WIDGET,
					 XmNleftWidget,       listInFiles,
					 XmNtopAttachment,    XmATTACH_WIDGET,
					 XmNtopWidget,        posModel,
					 XmNrightAttachment,  XmATTACH_NONE,
//				 XmNrightWidget,      BBmenu,
					 XmNbottomAttachment, XmATTACH_WIDGET,
					 XmNbottomWidget,     raWidget,
					 XmNleftOffset,       10,
					 XmNorientation,      XmVERTICAL,
					 XmNwidth,            40,
					 XmNheight,           20,
					 NULL ) ;

   //-->Z buffering, texture mapping
  readNextButton=XtVaCreateManagedWidget("ReadNext",
					xmPushButtonWidgetClass,
					threeButtons,
					NULL);
  XtAddCallback(readNextButton, XmNactivateCallback, M_InterPlann::readNextCB, this);
  showCoordSystem=XtVaCreateManagedWidget("ShowCoordSystem",
					  xmPushButtonWidgetClass,
					  threeButtons,
					  NULL);
  XtAddCallback(showCoordSystem, XmNactivateCallback, M_InterPlann::showCoordSystemCB, this);


  printIvFile=XtVaCreateManagedWidget("PrintIvFile",
				      xmPushButtonWidgetClass,
				      threeButtons,
				      NULL);
  XtAddCallback(printIvFile, XmNactivateCallback, M_InterPlann::printIvFileCB, this);
// Render Area
   n = 0;
   XtSetArg( args[n], XtNwidth, NWidth ); n++;
   XtSetArg( args[n], XtNheight, NHeight); n++;
   XtSetArg(args[n], XmNtopAttachment, XmATTACH_NONE);n++;
   XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM );n++;
   XtSetArg(args[n], XmNrightAttachment, XmATTACH_NONE);n++;
   XtSetArg(args[n], XmNbottomAttachment,XmATTACH_FORM);n++;
   XtSetValues(raWidget, args, n);

  // Make the widget visible
   XtManageChild(raWidget);

   return form;
 }





void
M_InterPlann::readNextCB( Widget w, XtPointer clientData,
			    XtPointer callData ){

    XmAnyCallbackStruct *call_data=(XmAnyCallbackStruct *)callData;
    M_InterPlann *ThisInstance = (M_InterPlann *) clientData;

    switch (call_data->reason){
    case XmCR_ACTIVATE:
	ThisInstance->Interface->set_ReadNext(TRUE);
	ThisInstance->callbackList->invokeCallbacks(
	    (void *) ThisInstance->Interface );
	ThisInstance->Interface->set_ReadNext(FALSE);
	break;
    default:
	printf("Button.... why are you here??\n");
	break;
    }
}

void
M_InterPlann::showCoordSystemCB( Widget w, XtPointer clientData,
				 XtPointer callData ){

    XmAnyCallbackStruct *call_data=(XmAnyCallbackStruct *)callData;
    M_InterPlann *ThisInstance = (M_InterPlann *) clientData;

    switch (call_data->reason){
    case XmCR_ACTIVATE:
	ThisInstance->Interface->set_ShowCoordSystem(TRUE);
	ThisInstance->callbackList->invokeCallbacks(
	    (void *) ThisInstance->Interface );
	ThisInstance->Interface->set_ShowCoordSystem(FALSE);
	break;
    default:
	printf("Button.... why are you here??\n");
	break;
    }
}
void
M_InterPlann::printIvFileCB( Widget w, XtPointer clientData,
			     XtPointer callData ){

    XmAnyCallbackStruct *call_data=(XmAnyCallbackStruct *)callData;
    M_InterPlann *ThisInstance = (M_InterPlann *) clientData;

    switch (call_data->reason){
    case XmCR_ACTIVATE:
	ThisInstance->Interface->set_printIvFile(TRUE);
	ThisInstance->callbackList->invokeCallbacks(
	    (void *) ThisInstance->Interface );
	ThisInstance->Interface->set_printIvFile(FALSE);
	break;
    default:
	printf("Button.... why are you here??\n");
	break;
    }
}
