#include <Inventor/Xt/SoXtRenderArea.h>
#include <Inventor/misc/SoCallbackList.h>
#include <Inventor/Xt/SoXtComponent.h>
#include <X11/Intrinsic.h>
#include <Inventor/SbBasic.h>

/*
#include "InterfaceXwithInv.h"
*/

#define Xt_default_min_d 12.50
#define Xt_default_max_d 20.50
#define Xt_default_dec_digits 2

#define NWidth  400
#define NHeight 200
class SoRotation;
class SoSeparator ;
class SoPerspectiveCamera;
class SoDirectionalLight;
class SoMaterial;
class DataToApp;


extern char *objectNames[];


typedef void SoXtM_InterPlannCB(void * userData,
            /* const M_InterfDataXwithInv *Interface*/
                              const  DataToApp *Interface);

#define F_NAME_SIZE    512

class DataToApp{
  private:
    //--New has to do with the way we texture map
    SbBool _doReadNext;
    SbBool _showCoordSystem;
    SbBool _printIvFile;

    SbBool globalVal;
 public:DataToApp();
    ~DataToApp();
    void set_GlobalVal(SbBool val){globalVal=val;};
    SbBool get_globalVal(){return globalVal;};
    void set_ReadNext(SbBool val){_doReadNext=val;};
    SbBool is_ReadNext(void)const{return _doReadNext;};
    void set_ShowCoordSystem(SbBool val){_showCoordSystem=val;};
    SbBool is_ShowCoordSystem(void)const{return _showCoordSystem;};
    void set_printIvFile(SbBool val){_printIvFile=val;};
    SbBool is_printIvFile()const{return _printIvFile;};
};

/*
 Class M_InterPlann
*/

class M_InterPlann : public SoXtRenderArea {
private:
    /* Interface with application */
    DataToApp *Interface;
    SoCallbackList *callbackList;

    /*
      Widgets:
      */
    Widget raWidget, form, threeButtons,posModel,listInFiles,
	readNextButton, showCoordSystem, printIvFile;


    /* Inventor's nodes */
    SoSeparator *Root;
    SoNode *userScene;
    SoPerspectiveCamera *Camera;
    SoMaterial  *Material;
    SoDirectionalLight *Light;

    // Common constructor
    void constructorCommon();
    Widget buildWidget(Widget parent);
    void CreateOptionMenu( Widget parent );
    // CallBacks from Xt Widget

    // TextField's (text) callback
static void readNextCB(Widget w, XtPointer clientData,
XtPointer callData);
static void showCoordSystemCB(Widget w, XtPointer clientData,
XtPointer callData);

static void printIvFileCB(Widget w, XtPointer clientData,
XtPointer callData);
  public:
  /* Constructor for public consumption */
   M_InterPlann(
     Widget parent = NULL,
     const char *name = NULL,
     SbBool buildInsideParent = TRUE,
     int num_dec_digits=Xt_default_dec_digits );
   ~M_InterPlann();

   DataToApp *getInterface() { return Interface; };

   virtual void setSceneGraph(SoNode *newScene);
/* Callback, add and remove: */
   inline void addScaleChangedCallback(
                            SoXtM_InterPlannCB *f,
                            void *userData = NULL);
   inline void removeScaleChangedCallback(
                            SoXtM_InterPlannCB *f,
                            void *userData = NULL);

}; /* End Class */


// Inline functions:

void
M_InterPlann::addScaleChangedCallback(
                         SoXtM_InterPlannCB *f,
                         void *userData)
{
 callbackList->addCallback( (SoCallbackListCB *) f, userData);
}



void
M_InterPlann::removeScaleChangedCallback(
                         SoXtM_InterPlannCB *f,
                         void *userData)
{
 callbackList->removeCallback( (SoCallbackListCB *) f, userData);
}
